diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/simple-ofdm-wimax-phy.h ns-3.38/src/wimax/model/simple-ofdm-wimax-phy.h
--- ns-3.37/src/wimax/model/simple-ofdm-wimax-phy.h	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/simple-ofdm-wimax-phy.h	2023-03-16 20:54:23.880869400 -0700
@@ -241,24 +241,24 @@
      * \param burst the packet burst
      * \returns the BVEC
      */
-    bvec ConvertBurstToBits(Ptr<const PacketBurst> burst);
+    Bvec ConvertBurstToBits(Ptr<const PacketBurst> burst);
     /**
      * Convert bits to burst
      * \param buffer the BVEC
      * \returns the packet burst
      */
-    Ptr<PacketBurst> ConvertBitsToBurst(bvec buffer);
+    Ptr<PacketBurst> ConvertBitsToBurst(Bvec buffer);
     /**
      * Create FEC blocks
      * \param buffer the BVEC
      * \param modulationType the modulation type
      */
-    void CreateFecBlocks(const bvec& buffer, WimaxPhy::ModulationType modulationType);
+    void CreateFecBlocks(const Bvec& buffer, WimaxPhy::ModulationType modulationType);
     /**
      * Recreate buffer
      * \returns BVEC
      */
-    bvec RecreateBuffer();
+    Bvec RecreateBuffer();
     /**
      * Get FEC block size
      * \param type the modulation type
@@ -303,13 +303,13 @@
      * \param burstSize the burst size
      * \param modulationType the modulation type
      * \param direction the direction
-     * \param drop the drop
+     * \param drop whether to drop
      * \param burst the burst
      */
     void EndReceiveFecBlock(uint32_t burstSize,
                             WimaxPhy::ModulationType modulationType,
                             uint8_t direction,
-                            uint8_t drop,
+                            bool drop,
                             Ptr<PacketBurst> burst);
     /**
      * Start end dummy FEC block
@@ -442,10 +442,10 @@
     uint16_t m_fecBlockSize;     ///< in bits, size of FEC block transmitted after PHY operations
     uint32_t m_currentBurstSize; ///< current burst size
 
-    std::list<bvec>* m_receivedFecBlocks; ///< a list of received FEC blocks until they are combined
+    std::list<Bvec>* m_receivedFecBlocks; ///< a list of received FEC blocks until they are combined
                                           ///< to recreate the full burst buffer
     uint32_t m_nrFecBlocksSent;   ///< counting the number of FEC blocks sent (within a burst)
-    std::list<bvec>* m_fecBlocks; ///< the FEC blocks
+    std::list<Bvec>* m_fecBlocks; ///< the FEC blocks
     Time m_blockTime;             ///< block time
 
     TracedCallback<Ptr<const PacketBurst>> m_traceRx; ///< trace receive callback
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/snr-to-block-error-rate-manager.h ns-3.38/src/wimax/model/snr-to-block-error-rate-manager.h
--- ns-3.37/src/wimax/model/snr-to-block-error-rate-manager.h	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/snr-to-block-error-rate-manager.h	2023-03-16 20:54:23.880869400 -0700
@@ -106,7 +106,7 @@
   private:
     /// Clear records function
     void ClearRecords();
-    uint8_t m_activateLoss;      ///< activate loss
+    bool m_activateLoss;         ///< activate loss
     std::string m_traceFilePath; ///< trace file path
 
     std::vector<SNRToBlockErrorRateRecord*>* m_recordModulation[7]; ///< record modulation
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/snr-to-block-error-rate-record.cc ns-3.38/src/wimax/model/snr-to-block-error-rate-record.cc
--- ns-3.37/src/wimax/model/snr-to-block-error-rate-record.cc	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/snr-to-block-error-rate-record.cc	2023-03-16 20:54:23.880869400 -0700
@@ -42,7 +42,7 @@
 }
 
 SNRToBlockErrorRateRecord*
-SNRToBlockErrorRateRecord::Copy()
+SNRToBlockErrorRateRecord::Copy() const
 {
     return (new SNRToBlockErrorRateRecord(m_snrValue,
                                           m_bitErrorRate,
@@ -53,7 +53,7 @@
 }
 
 double
-SNRToBlockErrorRateRecord::GetSNRValue()
+SNRToBlockErrorRateRecord::GetSNRValue() const
 {
     return m_snrValue;
 }
@@ -69,31 +69,31 @@
 }
 
 double
-SNRToBlockErrorRateRecord::GetBitErrorRate()
+SNRToBlockErrorRateRecord::GetBitErrorRate() const
 {
     return m_bitErrorRate;
 }
 
 double
-SNRToBlockErrorRateRecord::GetBlockErrorRate()
+SNRToBlockErrorRateRecord::GetBlockErrorRate() const
 {
     return m_blockErrorRate;
 }
 
 double
-SNRToBlockErrorRateRecord::GetSigma2()
+SNRToBlockErrorRateRecord::GetSigma2() const
 {
     return m_sigma2;
 }
 
 double
-SNRToBlockErrorRateRecord::GetI1()
+SNRToBlockErrorRateRecord::GetI1() const
 {
     return m_i1;
 }
 
 double
-SNRToBlockErrorRateRecord::GetI2()
+SNRToBlockErrorRateRecord::GetI2() const
 {
     return m_i2;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/snr-to-block-error-rate-record.h ns-3.38/src/wimax/model/snr-to-block-error-rate-record.h
--- ns-3.37/src/wimax/model/snr-to-block-error-rate-record.h	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/snr-to-block-error-rate-record.h	2023-03-16 20:54:23.880869400 -0700
@@ -54,32 +54,32 @@
     /**
      * \return the SNR value
      */
-    double GetSNRValue();
+    double GetSNRValue() const;
     /**
      * \return the BER value
      */
-    double GetBitErrorRate();
+    double GetBitErrorRate() const;
     /**
      * \return the BlcER value
      */
-    double GetBlockErrorRate();
+    double GetBlockErrorRate() const;
     /**
      * \return the standard deviation
      */
-    double GetSigma2();
+    double GetSigma2() const;
     /**
      * \return the lower boundary of the confidence interval
      */
-    double GetI1();
+    double GetI1() const;
     /**
      * \return the upper boundary of the confidence interval
      */
-    double GetI2();
+    double GetI2() const;
     /**
      * \brief copy a record
      * \return a copy of this record
      */
-    SNRToBlockErrorRateRecord* Copy();
+    SNRToBlockErrorRateRecord* Copy() const;
 
     /**
      * \brief set the snr value
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/ss-link-manager.cc ns-3.38/src/wimax/model/ss-link-manager.cc
--- ns-3.37/src/wimax/model/ss-link-manager.cc	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/ss-link-manager.cc	2023-03-16 20:54:23.880869400 -0700
@@ -337,7 +337,7 @@
 SSLinkManager::ResetRangingRequestCW()
 {
     m_rangingCW =
-        (uint8_t)std::pow((double)2, (double)m_ss->GetCurrentUcd().GetRangingBackoffStart()) - 1;
+        (uint8_t)std::pow(2.0, (double)m_ss->GetCurrentUcd().GetRangingBackoffStart()) - 1;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/ss-link-manager.h ns-3.38/src/wimax/model/ss-link-manager.h
--- ns-3.37/src/wimax/model/ss-link-manager.h	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/ss-link-manager.h	2023-03-16 20:54:23.880869400 -0700
@@ -78,7 +78,7 @@
      */
     bool GetRangingIntervalFound() const;
     /**
-     * Ser NR ranging trans opps
+     * Set NR ranging trans opps
      * \param nrRangingTransOpps the NR ranging trans opps
      */
     void SetNrRangingTransOpps(uint8_t nrRangingTransOpps);
@@ -90,7 +90,7 @@
     /// Increment NR invited polls received
     void IncrementNrInvitedPollsRecvd();
     /**
-     * Get DL map sync timeput event
+     * Get DL map sync timeout event
      * \returns the event ID
      */
     EventId GetDlMapSyncTimeoutEvent();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/ss-net-device.cc ns-3.38/src/wimax/model/ss-net-device.cc
--- ns-3.37/src/wimax/model/ss-net-device.cc	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/ss-net-device.cc	2023-03-16 20:54:23.880869400 -0700
@@ -581,7 +581,7 @@
 bool
 SubscriberStationNetDevice::HasServiceFlows() const
 {
-    return GetServiceFlowManager()->GetServiceFlows(ServiceFlow::SF_TYPE_ALL).size() > 0;
+    return !GetServiceFlowManager()->GetServiceFlows(ServiceFlow::SF_TYPE_ALL).empty();
 }
 
 Ptr<IpcsClassifier>
@@ -640,13 +640,13 @@
 }
 
 void
-SubscriberStationNetDevice::AddServiceFlow(ServiceFlow sf)
+SubscriberStationNetDevice::AddServiceFlow(ServiceFlow sf) const
 {
     GetServiceFlowManager()->AddServiceFlow(sf);
 }
 
 void
-SubscriberStationNetDevice::AddServiceFlow(ServiceFlow* sf)
+SubscriberStationNetDevice::AddServiceFlow(ServiceFlow* sf) const
 {
     GetServiceFlowManager()->AddServiceFlow(sf);
 }
@@ -1313,7 +1313,7 @@
         return; // nothing new in UCD so don't read
     }
     SetCurrentUcd(ucd);
-    m_linkManager->SetRangingCW((uint8_t)std::pow((double)2, (double)ucd.GetRangingBackoffStart()) -
+    m_linkManager->SetRangingCW((uint8_t)std::pow(2.0, (double)ucd.GetRangingBackoffStart()) -
                                 1); // initializing ranging CW
     OfdmUcdChannelEncodings ucdChnlEncodings = ucd.GetChannelEncodings();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/ss-net-device.h ns-3.38/src/wimax/model/ss-net-device.h
--- ns-3.37/src/wimax/model/ss-net-device.h	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/ss-net-device.h	2023-03-16 20:54:23.880869400 -0700
@@ -297,12 +297,12 @@
      * \brief adds a new service flow
      * \param sf pointer to service flow to add
      */
-    void AddServiceFlow(ServiceFlow* sf);
+    void AddServiceFlow(ServiceFlow* sf) const;
     /**
      * \brief adds a new service flow
      * \param sf service flow to add
      */
-    void AddServiceFlow(ServiceFlow sf);
+    void AddServiceFlow(ServiceFlow sf) const;
     /**
      * \brief Set timer.  If in stopped state, the EventId passed in the first
      * argument will be cancelled.  If not, the second parameter will be set
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/ss-record.cc ns-3.38/src/wimax/model/ss-record.cc
--- ns-3.37/src/wimax/model/ss-record.cc	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/ss-record.cc	2023-03-16 20:54:23.880869400 -0700
@@ -253,7 +253,7 @@
 }
 
 bool
-SSRecord::GetIsBroadcastSS()
+SSRecord::GetIsBroadcastSS() const
 {
     return m_broadcast;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/ss-record.h ns-3.38/src/wimax/model/ss-record.h
--- ns-3.37/src/wimax/model/ss-record.h	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/ss-record.h	2023-03-16 20:54:23.880869400 -0700
@@ -237,7 +237,7 @@
      * Get is broadcast SS
      * \returns the is broadcast SS flag
      */
-    bool GetIsBroadcastSS();
+    bool GetIsBroadcastSS() const;
 
     /**
      * Get IP address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/ss-service-flow-manager.h ns-3.38/src/wimax/model/ss-service-flow-manager.h
--- ns-3.37/src/wimax/model/ss-service-flow-manager.h	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/ss-service-flow-manager.h	2023-03-16 20:54:23.880869400 -0700
@@ -96,7 +96,7 @@
     EventId GetDsaRspTimeoutEvent() const;
     /**
      * Get DSA ack timeout event
-     * \returns the DSA ack timeput event
+     * \returns the DSA ack timeout event
      */
     EventId GetDsaAckTimeoutEvent() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/ul-job.cc ns-3.38/src/wimax/model/ul-job.cc
--- ns-3.37/src/wimax/model/ul-job.cc	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/ul-job.cc	2023-03-16 20:54:23.880869400 -0700
@@ -120,7 +120,7 @@
 }
 
 uint32_t
-UlJob::GetSize()
+UlJob::GetSize() const
 {
     return m_size;
 }
@@ -155,7 +155,7 @@
 }
 
 int
-PriorityUlJob::GetPriority()
+PriorityUlJob::GetPriority() const
 {
     return m_priority;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/ul-job.h ns-3.38/src/wimax/model/ul-job.h
--- ns-3.37/src/wimax/model/ul-job.h	2022-11-01 17:37:24.767396000 -0700
+++ ns-3.38/src/wimax/model/ul-job.h	2023-03-16 20:54:23.880869400 -0700
@@ -138,7 +138,7 @@
      * Get size
      * \returns the size
      */
-    uint32_t GetSize();
+    uint32_t GetSize() const;
     /**
      * Set size
      * \param size the size
@@ -176,7 +176,7 @@
      * Get priority
      * \returns the priority
      */
-    int GetPriority();
+    int GetPriority() const;
     /**
      * Set priority
      * \param priority the priority
@@ -184,7 +184,7 @@
     void SetPriority(int priority);
 
     /**
-     * Get UL job functiion
+     * Get UL job function
      * \returns the UL job
      */
     Ptr<UlJob> GetUlJob();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/wimax-tlv.cc ns-3.38/src/wimax/model/wimax-tlv.cc
--- ns-3.37/src/wimax/model/wimax-tlv.cc	2022-11-01 17:37:24.771396000 -0700
+++ ns-3.38/src/wimax/model/wimax-tlv.cc	2023-03-16 20:54:23.880869400 -0700
@@ -914,7 +914,7 @@
 void
 PortRangeTlvValue::Add(uint16_t portLow, uint16_t portHigh)
 {
-    struct PortRange tmp;
+    PortRange tmp;
     tmp.PortLow = portLow;
     tmp.PortHigh = portHigh;
     m_portRange->push_back(tmp);
@@ -1024,7 +1024,7 @@
 
 Ipv4AddressTlvValue::Ipv4AddressTlvValue()
 {
-    m_ipv4Addr = new std::vector<struct ipv4Addr>;
+    m_ipv4Addr = new std::vector<Ipv4Addr>;
 }
 
 Ipv4AddressTlvValue::~Ipv4AddressTlvValue()
@@ -1046,7 +1046,7 @@
 void
 Ipv4AddressTlvValue::Serialize(Buffer::Iterator i) const
 {
-    for (std::vector<struct ipv4Addr>::const_iterator iter = m_ipv4Addr->begin();
+    for (std::vector<Ipv4Addr>::const_iterator iter = m_ipv4Addr->begin();
          iter != m_ipv4Addr->end();
          ++iter)
     {
@@ -1070,12 +1070,9 @@
 }
 
 void
-Ipv4AddressTlvValue::Add(Ipv4Address address, Ipv4Mask Mask)
+Ipv4AddressTlvValue::Add(Ipv4Address address, Ipv4Mask mask)
 {
-    struct ipv4Addr tmp;
-    tmp.Address = address;
-    tmp.Mask = Mask;
-    m_ipv4Addr->push_back(tmp);
+    m_ipv4Addr->push_back({address, mask});
 }
 
 Ipv4AddressTlvValue::Iterator
@@ -1094,7 +1091,7 @@
 Ipv4AddressTlvValue::Copy() const
 {
     Ipv4AddressTlvValue* tmp = new Ipv4AddressTlvValue();
-    for (std::vector<struct ipv4Addr>::const_iterator iter = m_ipv4Addr->begin();
+    for (std::vector<Ipv4Addr>::const_iterator iter = m_ipv4Addr->begin();
          iter != m_ipv4Addr->end();
          ++iter)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wimax/model/wimax-tlv.h ns-3.38/src/wimax/model/wimax-tlv.h
--- ns-3.37/src/wimax/model/wimax-tlv.h	2022-11-01 17:37:24.771396000 -0700
+++ ns-3.38/src/wimax/model/wimax-tlv.h	2023-03-16 20:54:23.880869400 -0700
@@ -571,14 +571,15 @@
 class Ipv4AddressTlvValue : public TlvValue
 {
   public:
-    /// ipv4Addr structure
-    struct ipv4Addr
+    /// Ipv4Addr structure
+    struct Ipv4Addr
     {
         Ipv4Address Address; ///< address
         Ipv4Mask Mask;       ///< mask
     };
+
     /// IPv4 address vector iterator typedef
-    typedef std::vector<struct ipv4Addr>::const_iterator Iterator;
+    typedef std::vector<Ipv4Addr>::const_iterator Iterator;
     Ipv4AddressTlvValue();
     ~Ipv4AddressTlvValue() override;
     uint32_t GetSerializedSize() const override;
@@ -587,9 +588,9 @@
     /**
      * Add IPv4 address and mask
      * \param address the IPv4 address
-     * \param Mask the IPv4 mask
+     * \param mask the IPv4 mask
      */
-    void Add(Ipv4Address address, Ipv4Mask Mask);
+    void Add(Ipv4Address address, Ipv4Mask mask);
     /**
      * Begin iterator
      * \returns the beginning element
@@ -603,7 +604,7 @@
     Ipv4AddressTlvValue* Copy() const override;
 
   private:
-    std::vector<struct ipv4Addr>* m_ipv4Addr; ///< ipv4 addr
+    std::vector<Ipv4Addr>* m_ipv4Addr; ///< ipv4 addr
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/test.py ns-3.38/test.py
--- ns-3.37/test.py	2022-11-01 17:37:24.771396000 -0700
+++ ns-3.38/test.py	2023-03-16 20:54:23.880869400 -0700
@@ -754,7 +754,7 @@
 #     ...
 #   }
 #
-# You need to add a supression name which will only be printed out by valgrind in
+# You need to add a suppression name which will only be printed out by valgrind in
 # verbose mode (but it needs to be there in any case).  The entire stack frame is
 # shown to completely characterize the error, but in most cases you won't need
 # all of that info.  For example, if you want to turn off all errors that happen
@@ -810,18 +810,28 @@
     elapsed_time = time.time() - start_time
 
     retval = proc.returncode
-    try:
-        stdout_results = stdout_results.decode()
-    except UnicodeDecodeError:
-        print("Non-decodable character in stdout output of %s" % cmd)
-        print(stdout_results)
-        retval = 1
-    try:
-        stderr_results = stderr_results.decode()
-    except UnicodeDecodeError:
-        print("Non-decodable character in stderr output of %s" % cmd)
-        print(stderr_results)
-        retval = 1
+
+    def decode_stream_results(stream_results: bytes, stream_name: str) -> str:
+        try:
+            stream_results = stream_results.decode()
+        except UnicodeDecodeError:
+            def decode(byte_array: bytes):
+                try:
+                    byte_array.decode()
+                except UnicodeDecodeError:
+                    return byte_array
+
+            # Find lines where the decoding error happened
+            non_utf8_lines = list(map(lambda line: decode(line), stream_results.splitlines()))
+            non_utf8_lines = list(filter(lambda line: line is not None, non_utf8_lines))
+            print(f"Non-decodable characters found in {stream_name} output of {cmd}: {non_utf8_lines}")
+
+            # Continue decoding on errors
+            stream_results = stream_results.decode(errors="backslashreplace")
+        return stream_results
+
+    stdout_results = decode_stream_results(stdout_results, "stdout")
+    stderr_results = decode_stream_results(stderr_results, "stderr")
 
     if options.verbose:
         print("Return code = ", retval)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/utils/bench-scheduler.cc ns-3.38/utils/bench-scheduler.cc
--- ns-3.37/utils/bench-scheduler.cc	2022-11-01 17:37:24.771396000 -0700
+++ ns-3.38/utils/bench-scheduler.cc	2023-03-16 20:54:23.880869400 -0700
@@ -371,12 +371,14 @@
 #undef ACCUMULATE
     }
 
-    auto stdev = Result{{std::sqrt(moment2.init.time / n),
-                         std::sqrt(moment2.init.rate / n),
-                         std::sqrt(moment2.init.period / n)},
-                        {std::sqrt(moment2.run.time / n),
-                         std::sqrt(moment2.run.rate / n),
-                         std::sqrt(moment2.run.period / n)}};
+    auto stdev = Result{
+        {std::sqrt(moment2.init.time / n),
+         std::sqrt(moment2.init.rate / n),
+         std::sqrt(moment2.init.period / n)},
+        {std::sqrt(moment2.run.time / n),
+         std::sqrt(moment2.run.rate / n),
+         std::sqrt(moment2.run.period / n)},
+    };
 
     average.Log("average");
     stdev.Log("stdev");
@@ -401,7 +403,7 @@
 {
     Ptr<RandomVariableStream> stream = nullptr;
 
-    if (filename == "")
+    if (filename.empty())
     {
         LOG("  Event time distribution:      default exponential");
         auto erv = CreateObject<ExponentialRandomVariable>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/utils/ccache-miss-rate.py ns-3.38/utils/ccache-miss-rate.py
--- ns-3.37/utils/ccache-miss-rate.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/utils/ccache-miss-rate.py	2023-03-16 20:54:23.880869400 -0700
@@ -0,0 +1,8 @@
+#!/usr/bin/env python3
+
+import re
+import subprocess
+
+ccache_misses_line = subprocess.check_output(["ccache", "--print-stats"]).decode()
+ccache_misses = int(re.findall("cache_miss(.*)", ccache_misses_line)[0])
+print(ccache_misses)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/utils/codespell-ignored-lines ns-3.38/utils/codespell-ignored-lines
--- ns-3.37/utils/codespell-ignored-lines	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/utils/codespell-ignored-lines	2023-03-16 20:54:23.880869400 -0700
@@ -0,0 +1,46 @@
+#lollipop-counter.h: 341, 343
+        LollipopCounter ans = val;
+        return ans;
+
+#arp-header.cc: 202
+    ReadFrom(i, m_macDest, hardwareAddressLen);   // Read THA (size HLN)
+
+#csma-net-device.cc: 351-352
+            Ptr<Packet> padd = Create<Packet>(buffer, 46 - p->GetSize());
+            p->AddAtEnd(padd);
+
+#epc-gtpu-header.h: 236
+     * This field is used to co-ordinate the data transmission for acknowledged mode
+
+#mobility-model.cc:100, 102
+    Vector oPosition = other->DoGetPosition();
+    return CalculateDistance(position, oPosition);
+
+#statistics.rst:299-300
+    read ANS
+    if [ "$ANS" = "yes" -o "$ANS" = "y" ]
+
+#wifi-example-db.sh:34-35
+  read ANS
+  if [ "$ANS" = "yes" -o "$ANS" = "y" ]
+
+#doxygen.warnings.report.sh:483, 485, 544, 549, 556, 561
+filterin=
+    filterin=$(              \
+#     if [ "$filterin" != "" ] ; then
+#         echo "$filterin"
+if [ "$filterin" != "" ] ; then
+    echo "$filterin"
+
+#./src/visualizer/visualizer/hud.py:93-94
+            tbe = math.log10(dx_over_ndiv)#;   /* looking for approx. 'ndiv' divisions in a length 'dx' */
+            div = pow(10, rint(tbe))#;         /* div: power of 10 closest to dx/ndiv */
+
+#./utils/tests/test-ns3.py:2944
+            'convert {image} -colorspace HSI -channel b -separate +channel -scale 1x1 -format "%[fx:100*u]" info:'
+
+#./doc/tutorial/source/introduction.rst:80
+Network Animator nam.  It is not possible to run a simulation
+
+#./src/internet-apps/model/v4ping.h:37
+ * \brief an application which sends one ICMP ECHO request, waits for a REPLYs
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/utils/codespell-ignored-words ns-3.38/utils/codespell-ignored-words
--- ns-3.37/utils/codespell-ignored-words	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/utils/codespell-ignored-words	2023-03-16 20:54:23.880869400 -0700
@@ -0,0 +1,72 @@
+#Core
+anid
+anumber
+bu
+mone
+peripherial
+studi
+thre
+
+#Network
+ot
+nd
+
+#Internet
+devicec
+ect
+iif
+nce
+inflight
+
+#Internet Apps
+clen
+
+#Buildings
+nin
+
+#DSR
+cleanp
+
+#LTE
+commun
+couting
+ue
+ues
+
+#Netanim
+writen
+
+#Spectrum
+inh
+
+#Wave
+aci
+ois
+
+#Wifi
+fo
+
+#Traffic Control
+taht
+
+#Wimax
+opps
+
+#Propagation
+alos
+clos
+
+#Examples
+clienta
+
+#Brite
+brite
+
+#Mesh
+inport
+
+#Visualizer
+inout
+
+#Utils
+filetest
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/utils/create-module.py ns-3.38/utils/create-module.py
--- ns-3.37/utils/create-module.py	2022-11-01 17:37:24.771396000 -0700
+++ ns-3.38/utils/create-module.py	2023-03-16 20:54:23.880869400 -0700
@@ -50,9 +50,18 @@
 #ifndef {INCLUDE_GUARD}
 #define {INCLUDE_GUARD}
 
+// Add a doxygen group for this module.
+// If you have more than one file, this should be in only one of them.
+/**
+ * \defgroup {MODULE} Description of the {MODULE}
+ */
+
 namespace ns3
 {{
 
+// Each class should be documented using Doxygen,
+// and have an \ingroup {MODULE} directive
+
 /* ... */
 
 }}
@@ -82,6 +91,9 @@
 namespace ns3
 {{
 
+// Each class should be documented using Doxygen,
+// and have an \ingroup {MODULE} directive
+
 /* ... */
 
 }}
@@ -103,6 +115,12 @@
 #include "ns3/core-module.h"
 #include "ns3/{MODULE}-helper.h"
 
+/**
+ * \\file
+ *
+ * Explain here what the example does.
+ */
+
 using namespace ns3;
 
 int
@@ -136,7 +154,19 @@
 // to use the using directive to access the ns3 namespace directly
 using namespace ns3;
 
+// Add a doxygen group for tests.
+// If you have more than one test, this should be in only one of them.
+/**
+ * \defgroup {MODULE}-tests Tests for {MODULE}
+ * \ingroup {MODULE}
+ * \ingroup tests
+ */
+
 // This is an example TestCase.
+/**
+ * \ingroup {MODULE}-tests
+ * Test case for feature 1
+ */
 class {CAPITALIZED}TestCase1 : public TestCase
 {{
   public:
@@ -175,7 +205,11 @@
 // The TestSuite class names the TestSuite, identifies what type of TestSuite,
 // and enables the TestCases to be run.  Typically, only the constructor for
 // this class must be defined
-//
+
+/**
+ * \ingroup {MODULE}-tests
+ * TestSuite for module {MODULE}
+ */
 class {CAPITALIZED}TestSuite : public TestSuite
 {{
   public:
@@ -190,6 +224,10 @@
 }}
 
 // Do not forget to allocate an instance of this TestSuite
+/**
+ * \ingroup {MODULE}-tests
+ * Static variable for test initialization
+ */
 static {CAPITALIZED}TestSuite s{COMPOUND}TestSuite;
 '''
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/utils/print-introspected-doxygen.cc ns-3.38/utils/print-introspected-doxygen.cc
--- ns-3.37/utils/print-introspected-doxygen.cc	2022-11-01 17:37:24.771396000 -0700
+++ ns-3.38/utils/print-introspected-doxygen.cc	2023-03-16 20:54:23.884869300 -0700
@@ -40,6 +40,7 @@
 #include <iomanip>
 #include <iostream>
 #include <map>
+#include <utility> // as_const
 
 using namespace ns3;
 
@@ -96,14 +97,48 @@
 std::string templArgExplicit; ///< template argument required
 std::string templateArgument; ///< template argument
 std::string variable;         ///< variable or class member
-                              /** @} */
+
+/** @} */
+
+/**
+ * Alphabetize the AttributeInformation for a TypeId by the Attribute name
+ * \param tid The TypeId to process.
+ * \return The ordered list of Attributes.
+ */
+std::map<std::string, ns3::TypeId::AttributeInformation>
+SortedAttributeInfo(const TypeId tid)
+{
+    std::map<std::string, ns3::TypeId::AttributeInformation> index;
+    for (uint32_t j = 0; j < tid.GetAttributeN(); j++)
+    {
+        struct TypeId::AttributeInformation info = tid.GetAttribute(j);
+        index[info.name] = info;
+    }
+    return index;
+}
+
+/**
+ * Alphabetize the TraceSourceInformation for a TypeId by the
+ * TraceSource name.
+ * \param tid The TypeId to process.
+ * \return The ordered list of TraceSourceInformation
+ */
+std::map<std::string, ns3::TypeId::TraceSourceInformation>
+SortedTraceSourceInfo(const TypeId tid)
+{
+    std::map<std::string, ns3::TypeId::TraceSourceInformation> index;
+    for (uint32_t j = 0; j < tid.GetTraceSourceN(); j++)
+    {
+        struct TypeId::TraceSourceInformation info = tid.GetTraceSource(j);
+        index[info.name] = info;
+    }
+    return index;
+}
 
 } // unnamed namespace
 
 /**
  * Initialize the markup strings, for either doxygen or text.
- *
- * \param [in] outputText true for text output, false for doxygen output.
  */
 void
 SetMarkup()
@@ -664,11 +699,13 @@
 PrintAttributesTid(std::ostream& os, const TypeId tid)
 {
     NS_LOG_FUNCTION(tid);
+
+    auto index = SortedAttributeInfo(tid);
+
     os << listStart << std::endl;
-    for (uint32_t j = 0; j < tid.GetAttributeN(); j++)
+    for (const auto& [name, info] : index)
     {
-        struct TypeId::AttributeInformation info = tid.GetAttribute(j);
-        os << listLineStart << boldStart << info.name << boldStop << ": " << info.help << std::endl;
+        os << listLineStart << boldStart << name << boldStop << ": " << info.help << std::endl;
         os << indentHtmlOnly << listStart << std::endl;
         os << "    " << listLineStart << "Set with class: " << reference
            << info.checker->GetValueTypeName() << listLineStop << std::endl;
@@ -708,24 +745,10 @@
                 }
 
                 // Helper to match first part of string
-                class StringBeginMatcher
-                {
-                  public:
-                    StringBeginMatcher(const std::string s)
-                        : m_string(s){};
-
-                    bool operator()(const std::string t)
-                    {
-                        std::size_t pos = m_string.find(t);
-                        return pos == 0;
-                    };
-
-                  private:
-                    std::string m_string;
+                auto match = [&uType = std::as_const(underType)](const std::string& s) {
+                    return uType.rfind(s, 0) == 0; // only checks position 0
                 };
 
-                StringBeginMatcher match(underType);
-
                 if (match("bool") || match("double") || match("int8_t") || match("uint8_t") ||
                     match("int16_t") || match("uint16_t") || match("int32_t") ||
                     match("uint32_t") || match("int64_t") || match("uint64_t"))
@@ -743,7 +766,7 @@
         if (info.flags & TypeId::ATTR_CONSTRUCT && info.accessor->HasSetter())
         {
             std::string value = info.initialValue->SerializeToString(info.checker);
-            if (underType == "std::string" && value == "")
+            if (underType == "std::string" && value.empty())
             {
                 value = "\"\"";
             }
@@ -824,11 +847,13 @@
 PrintTraceSourcesTid(std::ostream& os, const TypeId tid)
 {
     NS_LOG_FUNCTION(tid);
+
+    auto index = SortedTraceSourceInfo(tid);
+
     os << listStart << std::endl;
-    for (uint32_t i = 0; i < tid.GetTraceSourceN(); ++i)
+    for (const auto& [name, info] : index)
     {
-        struct TypeId::TraceSourceInformation info = tid.GetTraceSource(i);
-        os << listLineStart << boldStart << info.name << boldStop << ": " << info.help << breakBoth;
+        os << listLineStart << boldStart << name << boldStop << ": " << info.help << breakBoth;
         if (!outputText)
         {
             //    '%' prevents doxygen from linking to the Callback class...
@@ -1016,13 +1041,14 @@
         {
             continue;
         }
-        os << boldStart << tid.GetName() << boldStop << breakHtmlOnly << std::endl;
 
+        auto index = SortedAttributeInfo(tid);
+
+        os << boldStart << tid.GetName() << boldStop << breakHtmlOnly << std::endl;
         os << listStart << std::endl;
-        for (uint32_t j = 0; j < tid.GetAttributeN(); ++j)
+        for (const auto& [name, info] : index)
         {
-            struct TypeId::AttributeInformation info = tid.GetAttribute(j);
-            os << listLineStart << boldStart << info.name << boldStop << ": " << info.help
+            os << listLineStart << boldStart << name << boldStop << ": " << info.help
                << listLineStop << std::endl;
         }
         os << listStop << std::endl;
@@ -1156,13 +1182,15 @@
         {
             continue;
         }
+
+        auto index = SortedTraceSourceInfo(tid);
+
         os << boldStart << tid.GetName() << boldStop << breakHtmlOnly << std::endl;
 
         os << listStart << std::endl;
-        for (uint32_t j = 0; j < tid.GetTraceSourceN(); ++j)
+        for (const auto& [name, info] : index)
         {
-            struct TypeId::TraceSourceInformation info = tid.GetTraceSource(j);
-            os << listLineStart << boldStart << info.name << boldStop << ": " << info.help
+            os << listLineStart << boldStart << name << boldStop << ": " << info.help
                << listLineStop << std::endl;
         }
         os << listStop << std::endl;
@@ -1359,13 +1387,13 @@
 } // PrintMakeChecker ()
 
 /**Descriptor for an AttributeValue. */
-typedef struct
+struct AttributeDescriptor
 {
     const std::string m_name;   //!< The base name of the resulting AttributeValue type.
     const std::string m_type;   //!< The name of the underlying type.
     const bool m_seeBase;       //!< Print a "see also" pointing to the base class.
     const std::string m_header; //!< The header file name.
-} AttributeDescriptor;
+};
 
 /**
  * Print documentation corresponding to use of the
@@ -1444,7 +1472,7 @@
     // clang-format on
 
     int i = 0;
-    while (attributes[i].m_name != "")
+    while (!attributes[i].m_name.empty())
     {
         PrintAttributeHelper(os, attributes[i]);
         ++i;
